#!/usr/bin/env python
'''
gogo_mini.py - A very simple frontend for gorecord
Copyright (C) 2007  nikosapi (nikosapi@gmail.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
'''

# -*- coding: UTF8 -*-

# Python module gogo_mini.py
# Autogenerated from gogo-mini.glade
# Generated on Sun Mar 25 19:37:16 2007

# Warning: Do not modify any context comment such as #--
# They are required to keep user's code

import os

import gtk

from SimpleGladeApp import SimpleGladeApp
from SimpleGladeApp import bindtextdomain

import libgogo_mini
from threading import Thread
from time import sleep
from os.path import exists, expanduser

app_name = "gogo-mini"
app_version = "1.1"

glade_dir = '../share/gogo-mini/'
locale_dir = ''

bindtextdomain(app_name, locale_dir)

class MainWindow(SimpleGladeApp):

    def __init__(self, path="gogo-mini.glade",root="main_window",domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)

    #-- MainWindow.new {
    def new(self):
            self.label2.set_text("Welcome to the GoGoRecord mini version.")
    #-- MainWindow.new }

    #-- MainWindow custom methods {
    def write_to_infobox(self, message):
            gtk.gdk.threads_enter()
            self.label2.set_text(message)
            gtk.gdk.threads_leave()

    def infobox_thread(self):
        sleep(1)
        if self.gogo.sleeping:
            while self.gogo.sleeping:
                time_left = str((self.gogo.sleep_time_sec - self.gogo.sleep_current_sec) + 1)
                message = "Recording in: " + time_left + " seconds."
                self.write_to_infobox(message)
                sleep(0.1)
        if self.gogo.was_killed:
            self.write_to_infobox("Recoring stopped by user.")
        else:
            # make sure the gorecord process has started (by sleeping) before checking to see if it's started
            sleep(2)
            if self.gogo.gorecord_process.poll() == -1:
                while self.gogo.gorecord_process.poll() == -1:
                    message = "Time: " + self.gogo.rec_time + "  Bitrate: " + self.gogo.current_bitrate
                    self.write_to_infobox(message)
                    sleep(0.1)
                if self.gogo.was_killed:
                    self.write_to_infobox("Recoring stopped by user.")
                else:
                    self.write_to_infobox("Recording Complete ^_^")
                    self.record.set_active(False)
            else:
                self.write_to_infobox("Error starting gorecord :-(")
                self.record.set_active(False)

    def infobox_thread_start(self):
        thread = Thread(target=self.infobox_thread)
        thread.start()
    #-- MainWindow custom methods }

    #-- MainWindow.on_main_window_destroy {
    def on_main_window_destroy(self, widget, *args):
        try:
            self.gogo.stop_record()
        except:
            pass
        self.gtk_main_quit()
    #-- MainWindow.on_main_window_destroy }

    #-- MainWindow.on_choose_button_clicked {
    def on_choose_button_clicked(self, widget, *args):
        filechooserdialog = Filechooserdialog()
    #-- MainWindow.on_choose_button_clicked }

    #-- MainWindow.on_record_toggled {
    def on_record_toggled(self, widget, *args):
        if self.record.get_active():
            self.label2.set_text("About to Record...")
            raw_prefix = self.entry1.get_text().split()
            prefix = ""
            for part in raw_prefix:
                prefix = prefix + "_" + part 
            prefix = prefix[1:]
            if prefix.strip() == "":
                prefix = "Unknown"
            duration = self.entry2.get_text()
            if duration == "":
                duration = "62"
            sleep_time = self.entry3.get_text()
            if sleep_time == "":
                sleep_time = "0"
            bitrate_lookup = ["1200","1600","2000","2400","2800","3200","3600","4000", "5000", "6000", "2400"]
            bitrate = bitrate_lookup[self.comboboxentry1.get_active()]
            settings = libgogo_mini.gogo_settings()
            settings.read_settings()
            record_dir = settings.record_dir

            # Start the record thread
            self.gogo = libgogo_mini.record_thread(duration, prefix, bitrate, sleep_time, record_dir)
            self.gogo.start_record()
            # Start the infobox thread
            self.infobox_thread_start()

        else:
            # If the button is pushed out by the user stop recording
            self.gogo.stop_record()

                #-- MainWindow.on_record_toggled }


class Filechooserdialog(SimpleGladeApp):

    def __init__(self, path="gogo-mini.glade", root="filechooserdialog", domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)
    gtk.gdk.threads_init()
    #-- Filechooserdialog.new {
    def new(self):
        settings = libgogo_mini.gogo_settings()
        settings.read_settings(False)
        if exists(settings.record_dir):
            self.filechooserdialog.set_current_folder(settings.record_dir)
        else:
            self.filechooserdialog.set_current_folder(expanduser("~"))
    #-- Filechooserdialog.new }

    #-- Filechooserdialog custom methods {
    #-- Filechooserdialog custom methods }

    #-- Filechooserdialog.on_dir_cancel_clicked {
    def on_dir_cancel_clicked(self, widget, *args):
        self.filechooserdialog.destroy()
    #-- Filechooserdialog.on_dir_cancel_clicked }

    #-- Filechooserdialog.on_dir_select_clicked {
    def on_dir_select_clicked(self, widget, *args):
        settings = libgogo_mini.gogo_settings()
        settings.write_settings(self.filechooserdialog.get_filename())
        self.filechooserdialog.destroy()
    #-- Filechooserdialog.on_dir_select_clicked }


#-- main {

def main():
    main_window = MainWindow()
    main_window.run()

if __name__ == "__main__":
    main()

#-- main }
